
/*
 * Unknown author from France
 * Century XX
 */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/xf86vmode.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int
setXmode (int x, int y)
{
	int     modecount = 0, i;

	Display *display;
	XF86VidModeModeInfo **modesinfo = 0;

	if (!(display = XOpenDisplay (0)))
	{
		fprintf (stderr, "Cannot open display.\n");
		return 1;
	}
	if (!XF86VidModeGetAllModeLines
	    (display, XDefaultScreen (display), &modecount, &modesinfo)
	    || modecount <= 0 || !modesinfo)
	{
		fprintf (stderr, "Cannot get video modes.\n");
		return 0;
	}

	for (i = 0; i < modecount; ++i)
	{
		if (!modesinfo[i])
			break;

		if (x == 0 && y == 0)
			printf ("Resolution %d : %d x %d\n", i,
				modesinfo[i]->hdisplay,
				modesinfo[i]->vdisplay);

		else if (x == modesinfo[i]->hdisplay
			 && y == modesinfo[i]->vdisplay)
		{
			if (!XF86VidModeSwitchToMode
			    (display, XDefaultScreen (display),
			     modesinfo[i]) || !XFlush (display))
			{
				fprintf (stderr, "Cannot set video mode.\n");
				return 1;
			}
		}
	}
	return 0;
}

int
main (int ac, const char **av)
{
	int     x = 0, y = 0;

	if (ac == 1)
		return setXmode (0, 0);

	if (ac == 3)
	{
		x = atoi (av[1]);
		y = atoi (av[2]);
		printf ("Setting resolution '%d x %d'\n", x, y);
		return setXmode (x, y);
	}

	return 1;
}
